/*
 * GenericValue.cpp: Python bindings for the LLVM compiler infrastructure
 * Copyright (c) 2004, 2005 Jarno Seppänen <firstname.lastname@iki.fi>.
 * Distributed under the Boost Software License, Version 1.0. (See
 * accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#include <boost/python.hpp>
#include <boost/noncopyable.hpp>
//#include <boost/python/suite/indexing/vector_indexing_suite.hpp>
#include <llvm/ExecutionEngine/GenericValue.h>
#include "GenericValueHolder.h"

using namespace boost::python;

namespace llvm { namespace Python {

void wrap_GenericValue()
{
    class_<GenericValueHolder>("GenericValue")
        .add_property("BoolVal", &GenericValueHolder::get_BoolVal, &GenericValueHolder::set_BoolVal)
        .add_property("UByteVal", &GenericValueHolder::get_UByteVal, &GenericValueHolder::set_UByteVal)
        .add_property("SByteVal", &GenericValueHolder::get_SByteVal, &GenericValueHolder::set_SByteVal)
        .add_property("UShortVal", &GenericValueHolder::get_UShortVal, &GenericValueHolder::set_UShortVal)
        .add_property("ShortVal", &GenericValueHolder::get_ShortVal, &GenericValueHolder::set_ShortVal)
        .add_property("UIntVal", &GenericValueHolder::get_UIntVal, &GenericValueHolder::set_UIntVal)
        .add_property("IntVal", &GenericValueHolder::get_IntVal, &GenericValueHolder::set_IntVal)
        .add_property("ULongVal", &GenericValueHolder::get_ULongVal, &GenericValueHolder::set_ULongVal)
        .add_property("LongVal", &GenericValueHolder::get_LongVal, &GenericValueHolder::set_LongVal)
        .add_property("DoubleVal", &GenericValueHolder::get_DoubleVal, &GenericValueHolder::set_DoubleVal)
        .add_property("FloatVal", &GenericValueHolder::get_FloatVal, &GenericValueHolder::set_FloatVal)
        //FIXME anonymous struct
        //.add_property("UIntPairVal", &GenericValueHolder::get_UIntPairVal, &GenericValueHolder::set_UIntPairVal)
        .add_property("PointerVal", &GenericValueHolder::get_PointerVal, &GenericValueHolder::set_PointerVal)
        ;

    implicitly_convertible<GenericValue, GenericValueHolder>();
    implicitly_convertible<GenericValueHolder, GenericValue>();

    // Wrap GenericValue(void*)
    //implicitly_convertible<void*, GenericValue>();

    /*
    class_<std::vector<GenericValueHolder> >("GenericValueVector")
        .def(vector_indexing_suite<std::vector<GenericValueHolder> >())
        ;

    //FIXME
    //implicitly_convertible<std::vector<GenericValue>, std::vector<GenericValueHolder> >();
    //implicitly_convertible<std::vector<GenericValueHolder>, std::vector<GenericValue> >();
    */
}
}} // namespace llvm::Python

// EOF
