/*
 * Intrinsics.cpp: Python bindings for the LLVM compiler infrastructure
 * Copyright (c) 2004, 2005 Jarno Seppänen <firstname.lastname@iki.fi>.
 * Distributed under the Boost Software License, Version 1.0. (See
 * accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#include <boost/python.hpp>
#include <boost/noncopyable.hpp>
#include <llvm/Intrinsics.h>

using namespace boost::python;

namespace llvm { namespace Python {

using namespace Intrinsic;

void wrap_Intrinsics(object module)
{
    scope IntrinsicScope = module;

    enum_<ID>("ID")
        .value("not_intrinsic", not_intrinsic)
        .value("vastart", vastart)
        .value("vaend", vaend)
        .value("vacopy", vacopy)
        .value("returnaddress", returnaddress)
        .value("frameaddress", frameaddress)
        .value("setjmp", setjmp)
        .value("longjmp", longjmp)
        .value("sigsetjmp", sigsetjmp)
        .value("siglongjmp", siglongjmp)
        .value("gcroot", gcroot)
        .value("gcread", gcread)
        .value("gcwrite", gcwrite)
        .value("dbg_stoppoint", dbg_stoppoint)
        .value("dbg_region_start", dbg_region_start)
        .value("dbg_region_end", dbg_region_end)
        .value("dbg_func_start", dbg_func_start)
        .value("dbg_declare", dbg_declare)
        .value("memcpy", memcpy)
        .value("memmove", memmove)
        .value("memset", memset)
        .value("isunordered", isunordered)
        .value("readport", readport)
        .value("writeport", writeport)
        .value("readio", readio)
        .value("writeio", writeio)
        ;
}

}} // namespace llvm::Python

// EOF
