/*
 * Use.cpp: Python bindings for the LLVM compiler infrastructure
 * Copyright (c) 2004, 2005 Jarno Seppänen <firstname.lastname@iki.fi>.
 * Distributed under the Boost Software License, Version 1.0. (See
 * accompanying file LICENSE_1_0.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt)
 */

#include <boost/python.hpp>
#include <boost/noncopyable.hpp>
#include <llvm/Use.h>
#include <llvm/User.h>
#include <llvm/Value.h>

using namespace boost::python;

namespace llvm { namespace Python {

void wrap_Use()
{
    class_<Use>("Use",
                init<Value*, User*>()
                [with_custodian_and_ward<1, 2,
                     with_custodian_and_ward<1, 3> >()])
        // additional constructors
        .def(init<const Use&>())

        .def("get", &Use::get,
             return_internal_reference<>())
        .def("getUser", &Use::getUser,
             return_internal_reference<>())
        .def("set", &Use::set,
             with_custodian_and_ward<1, 2>())
        ;

    // Wrap Use::operator Value*()
    implicitly_convertible<Use, Value*>();
}
}} // namespace llvm::Python

// EOF
