"""
Test instruction ownership.

>>> b=llvm.BasicBlock()
>>> r=llvm.ReturnInst(b)
>>> gc.collect()
0
>>> del r
>>> gc.collect()
0
>>> del b
>>> gc.collect()
0

Misc Python llvm module tests.

>>> m=llvm.Module("test")
>>> f = m.getOrInsertFunction("fun", llvm.Type.VoidTy)
>>> del f
>>> del m
>>> gc.collect()
0

Try out bytecode reader.

>>> m=llvm.ParseBytecodeFile("hello.ll.bc")
>>> m is None
False
>>> main=m.getNamedFunction("main")
>>> main.getFunctionType().getDescription()
'int ()'

Try out JIT

>>> mp=llvm.getBytecodeModuleProvider("hello.ll.bc")
>>> jit=llvm.ExecutionEngine.create(mp, False)
>>> main=mp.getModule().getMainFunction()
>>> ret=jit.runFunction(main, ()) # prints hello
>>> ret.IntVal
0
"""

import doctest, gc, llvm

if __name__=="__main__":
    doctest.testmod()
